function mtap(element) {
    var r = element.getBoundingClientRect();

    var cx = r.x + r.width * (10 + Math.floor(Math.random() * 81)) / 100;
    var cy = r.y + r.height * (10 + Math.floor(Math.random() * 81)) / 100;

    var sx = cx;
    var sy = cy + 72;

    var e = document.createEvent("MouseEvents");

    e.initMouseEvent(
        "click",
        true,
        true,
        window,
        1,
        sx,
        sy,
        cx,
        cy,
        false,
        false,
        false,
        false,
        0,
        null
    );

    element.dispatchEvent(e);
}

function tap(element) {
    scroll2element(element);

    setTimeout(function(elmt) {
        var rect = elmt.getBoundingClientRect();

        alert("tap:" + rect.left + "," + rect.top + "," + rect.right + "," + rect.bottom);
    }, 2200, element);
}

function scroll2bottom() {
    var r = document.body.getBoundingClientRect();

    window.scrollTo(window.scrollX, window.scrollY + r.bottom);
}

function scroll2element(element) {
    var r = element.getBoundingClientRect();

    var dy = r.top - 180 + Math.floor(Math.random() * 100);

    window.scrollTo(window.scrollX, window.scrollY + dy);
}

function tapunfold() {
    var elements = document.querySelectorAll("#J_article a.Unfolded-link");

    if(elements.length > 0) {
        scroll2element(elements[0]);

        window.setTimeout(function () {
            mtap(elements[0]);
        }, 1200 + Math.floor(Math.random() * 500));
    }
}

function tapimg() {
    var elements = document.querySelectorAll("#J_article>div#content img");

    if(elements.length > 0) {
        var index = Math.floor(Math.random() * elements.length);

        scroll2element(elements[index]);

        window.setTimeout(function () {
            tap(elements[index]);
        }, 1200 + Math.floor(Math.random() * 500));
    }
}

function tapnews() {
    var links = document.querySelectorAll("#J_hn_list a.news-link[data-type][href*='//']");

    if(links.length > 0) {
        var index = Math.floor(Math.random() * links.length);

        var url = links[index].href;

        alert("value:origin-url=" + url);

        scroll2element(links[index]);

        window.setTimeout(function () {
            tap(links[index]);
        }, 1200 + Math.floor(Math.random() * 500));

        alert("done:tapnews");
    } else {
        alert("tapnews not found news");
    }
}

function tapdsp() {
    var links = document.querySelectorAll("a.news-link.J-dsp-news[data-advurl]");

    if(links.length > 0) {
        var index = Math.floor(Math.random() * links.length);

        scroll2element(links[index]);

        window.setTimeout(function () {
            tap(links[index]);
        }, 1200 + Math.floor(Math.random() * 500));

        alert("done:tapdsp");
    } else {
        alert("tapdsp not found dsp");
    }
}

function tap2ranking(i) {
    var iframes = document.querySelectorAll("iframe");

    if(i >= 0 && i < iframes.length) {
        tap(iframes[i]);
    } else {
        alert("tap2ranking not found iframe");
    }
}

function search4ads() {
    var iframes = document.querySelectorAll("iframe");
    var messages = [];

    for(var i = 0; i < iframes.length; i++) {
        if(iframes[i].height > 50) {
            var message = "search4ads#" + i;

            iframes[i].contentWindow.postMessage(message, "*");

            messages.push(message);
        }
    }

    alert("value:search4ads-messages=" + messages.join(","));
}

function tap2brand() {
    var links;

    links = document.querySelectorAll("div.ec_ad_results a.ec_title");

    if(links.length > 0) {
        var index = Math.floor(Math.random() * links.length);

        mtap(links[index]);

        for(var i = 0; i < links.length; i++) {
            if(i != index) {
                alert("value:brand-url=" + links[i].href);
            }
        }

        alert("done:tap2brand");

        return;
    }

    links = document.querySelectorAll("div.tab-asp-content a.inner-item,div.tab-feed-content div[id*='asp'] a.inner-item");

    if(links.length > 0) {
        var index = Math.floor(Math.random() * links.length);

        mtap(links[index]);

        for(var i = 0; i < links.length; i++) {
            if(i != index) {
                alert("value:brand-url=" + links[i].href);
            }
        }

        alert("done:tap2brand");

        return;
    }

    var url = window.location.href;

    alert("tap2brand not found ads, url=" + url);
}

window.addEventListener("message", function(event) {
    var message = event.data;

    if(message.includes("search4ads")) {
        if(document.title.includes("百度") || document.querySelectorAll("div#bdNewLogo,div#bdNewLogoHand").length > 0) {
            alert("value:search4ads-success=" + message);
        } else {
            var iframes = document.querySelectorAll("iframe");

            for(var i = 0; i < iframes.length; i++) {
                iframes[i].contentWindow.postMessage(message, "*");
            }
        }
    }

});
